From 75aea9ab732b6d6377502b51378077bbd634ccdf Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 16 2020 00:10:08 +0000
Subject: [PATCH 1406/2232] Enforce receiver pinning


---

diff --git a/syntax/check.rs b/syntax/check.rs
index 5876cf7..7e368f4 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -269,6 +269,17 @@ fn check_api_fn(cx: &mut Check, efn: &ExternFn) {
             && !cx.types.rust.contains(&receiver.ty.rust)
         {
             cx.error(span, "unrecognized receiver type");
+        } else if receiver.mutability.is_some()
+            && !receiver.pinned
+            && is_opaque_cxx(cx, &receiver.ty.rust)
+        {
+            cx.error(
+                span,
+                format!(
+                    "mutable reference to C++ type requires a pin -- use `self: Pin<&mut {}>`",
+                    receiver.ty.rust,
+                ),
+            );
         }
 
         if receiver.lifetime.is_some() {

